
# temporary to debug failing tests on the build server
def bputs(msg)
  if ENV["BUILD_PUTS"] == "1"
    puts msg
  end
end

bputs "before simplecov"

require 'simplecov'
bputs "before rubygems"
require 'rubygems'
bputs "before omniauth"
#require 'spork'
require 'omniauth'
#uncomment the following line to use spork with the debugger
#require 'spork/ext/ruby-debug'
require 'yaml'


ENV["RAILS_ENV"] ||= 'test'

bputs "before activerecord load"

require 'active_record'
require 'action_mailer'
#require 'jam_db'
require "#{File.dirname(__FILE__)}/spec_db"

bputs "before db_config load"
db_config = YAML::load(File.open('config/database.yml'))["test"]

# initialize ActiveRecord's db connection\
bputs "before connect db"
ActiveRecord::Base.establish_connection(db_config)

SpecDb::recreate_database if ENV['SKIP_DB_PREP'].nil?

bputs "before load jam_ruby"
require 'jam_ruby'

bputs "before recreate db"
# recreate test database and migrate it

# uncomment this to see active record logs
# ActiveRecord::Base.logger = Logger.new(STDOUT) if defined?(ActiveRecord::Base)

include JamRuby
# put ActionMailer into test mode
ActionMailer::Base.delivery_method = :test
RecordedTrack.observers.disable :all # only a few tests want this observer active

# disable test-unit autorun behavior: https://github.com/grosser/parallel_tests/issues/189
require "test/unit"
Test::Unit::AutoRunner.need_auto_run = false

IS_BUILD_SERVER = !ENV['BUILD_SERVER'].nil?

# a way to kill tests if they aren't running. capybara is hanging intermittently, I think
tests_started = false

Thread.new {
  if ENV['BUILD_NUMBER']
    sleep 240
  else
    sleep 30
  end

  unless tests_started
    bputs "tests are hung. exiting..."
    puts "tests are hung. exiting..."
    exit! 20
  end
}

# to prevent embedded resque code from forking
ENV['FORK_PER_JOB'] = 'false'

bputs "before load websocket server"

current = Thread.current
Thread.new do
  ActiveRecord::Base.connection.disconnect!
  ActiveRecord::Base.establish_connection(YAML::load(File.open('config/database.yml'))["test"])
  require 'jam_websockets'
  begin
    JamWebsockets::Server.new.run(
        :port => 6759,
        :emwebsocket_debug =>  false,
        :connect_time_stale_client => 4,
        :connect_time_expire_client => 6,
        :connect_time_stale_browser => 4,
        :connect_time_expire_browser => 6,
        :max_connections_per_user => 20,
        :rabbitmq_host => '127.0.0.1',
        :rabbitmq_port => 5672,
        :calling_thread => current,
        :cidr => ['0.0.0.0/0'],
        :gateway_name => 'default-test')
  rescue Exception => e
    puts "websocket-gateway failed: #{e}"
  end
end

bputs "before websocket thread wait"
Thread.stop

bputs "before connection reestablish"

ActiveRecord::Base.connection.disconnect!
bputs "before connection reestablishing"
ActiveRecord::Base.establish_connection(YAML::load(File.open('config/database.yml'))["test"])
#Spork.prefork do
  # Loading more in this block will cause your tests to run faster. However,
  # if you change any configuration or code from libraries loaded here, you'll
  # need to restart spork for it take effect.
  # This file is copied to spec/ when you run 'rails generate rspec:install'
bputs "before load environment"
begin
  require File.expand_path("../../config/environment", __FILE__)
rescue => e
  bputs "exception in load environment"
  bputs "e: #{e}"
end

bputs "before loading rails"
  require 'rspec/rails'
#  require 'rspec/autorun'


bputs "before load capybara"
  require 'capybara'
  require 'capybara/rails'
  require 'webdrivers'
  require 'capybara/rspec'
  require 'capybara-screenshot/rspec'
#  require 'capybara/poltergeist'
bputs "before register capybara"
Capybara::Screenshot::RSpec.add_link_to_screenshot_for_failed_examples = true
Capybara::Screenshot.prune_strategy = :keep_last_run
#  Capybara.register_driver :poltergeist do |app|
#    # '--load-images=no'
#    driver = Capybara::Poltergeist::Driver.new(app, { debug: false, phantomjs_logger: File.open('log/phantomjs.out', 'w'), phantomjs_options: ['--ignore-ssl-errors=yes'] })
#  end
#  Capybara.javascript_driver = :poltergeist
  Capybara.default_max_wait_time = 10
Capybara.default_driver = :selenium
Capybara.server = :puma

#Capybara.register_driver :selenium do |app|
#  Capybara::Selenium::Driver.new(app, browser: :firefox)
#end
#  if defined?(TEST_CONNECT_STATES) && TEST_CONNECT_STATES
#    TEST_CONNECT_STATE_JS_CONSOLE_IO = File.open(TEST_CONNECT_STATE_JS_CONSOLE, 'w')
#    Capybara.register_driver :poltergeist do |app|
#      Capybara::Poltergeist::Driver.new(app, { phantomjs_logger: TEST_CONNECT_STATE_JS_CONSOLE_IO })
#    end
    #Capybara.javascript_driver = :poltergeist
#  end
  Capybara.configure do |config|
    config.match = :one
    #config.exact_options = true
    config.ignore_hidden_elements = true
    config.visible_text_only = true
  end

  # Requires supporting ruby files with custom matchers and macros, etc,
  # in spec/support/ and its subdirectories.
  Dir[Rails.root.join("spec/support/**/*.rb")].each {|f| require f}

  #ActiveRecord::Base.logger = Logger.new(STDOUT) if defined?(ActiveRecord::Base)

  RSpec.configure do |config|

    # ## Mock Framework
    #
    # If you prefer to use mocha, flexmock or RR, uncomment the appropriate line:
    #
    # config.mock_with :mocha
    # config.mock_with :flexmock
    # config.mock_with :rr
    config.mock_with :rspec
    config.color = true
    config.include ShowMeTheCookies, :type => :feature
    config.example_status_persistence_file_path = 'tmp/examples.txt'

    config.include ApiHelper, type: :api

    # by default, do not run tests marked as 'slow'
    config.filter_run_excluding slow: true unless ENV['RUN_SLOW_TESTS'] == "1" || ENV['SLOW'] == "1" || ENV['ALL_TESTS'] == "1"
    config.filter_run_excluding aws: true unless ENV['RUN_AWS_TESTS'] == "1" || ENV['AWS'] == "1" || ENV['ALL_TESTS'] == "1"
    config.filter_run_excluding intermittent: true if IS_BUILD_SERVER

    # Remove this line if you're not using ActiveRecord or ActiveRecord fixtures
    config.fixture_path = "#{::Rails.root}/spec/fixtures"

    # If you're not using ActiveRecord, or you'd prefer not to run each of your
    # examples within a transaction, remove the following line or assign false
    # instead of true.
    config.use_transactional_fixtures = false

    # If true, the base class of anonymous controllers will be inferred
    # automatically. This will be the default behavior in future versions of
    # rspec-rails.
    config.infer_base_class_for_anonymous_controllers = false

    config.include Requests::JsonHelpers, type: :request
    config.include Requests::FeatureHelpers, type: :feature

    # Use the specified formatter
    config.formatter = :documentation

    config.before(:suite) do
      tests_started = true
    end

    config.expect_with(:rspec) { |c| c.syntax = [:should, :expect] }

    config.before(:all) do
      # to reduce frequency of timeout on initial test
      # https://github.com/teampoltergeist/poltergeist/issues/294#issuecomment-72746472
      #if self.respond_to? :visit
      #  visit '/assets/application.css'
      #  visit '/assets/application.js'
      #end
    end

    config.before(:each) do |example|
      #if example.metadata[:js] && (Capybara.current_driver.nil? || Capybara.current_driver.empty? || Capybara.current_driver==:selenium)
      #  page.driver.resize(1920, 1080)
      #  page.driver.headers = { 'User-Agent' => 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:25.0) Gecko/20100101 Firefox/25.0' }
      #end

    end

    config.before(:each, :js => true) do
      #
      #Timeout.timeout(Capybara.default_max_wait_time) do
      #  until (i = page.evaluate_script("$.active")).zero?
      #    Rails.logger.info "example [#{example.description}] has #{i} outstanding XHR(s)"
      #    sleep 0.1
      #  end
      #end
    end

    config.append_after(:each) do

      Capybara.reset_sessions!
      reset_session_mapper
    end

    config.after(:each) do |example|

      Timecop.return

      if example.metadata[:js]
      end

      # dump response.body if an example fails
      if example.metadata[:type] == :controller && example.exception
        puts "'#{determine_test_name(example.metadata)}' controller test failed."
        puts "response.status = #{response.status}, response.body = " + response.body
      end
    end

    config.after(:all) do

    end

    config.after(:suite) do
      puts "S3 Bucket cleanup disabled"
      #wipe_s3_test_bucket
    end
  end
#end

#Spork.each_run do
  # This code will be run each time you run your specs.

#end






